program LinebyLineR
implicit none
integer::i,j,Nx,Ny,N
double precision,allocatable,dimension(:)::x,y,a,b,c,r,s
double precision,allocatable,dimension(:,:)::T,Told
double precision::u,v,dx,dy,Pex,Pey,d,Lx,Ly,Alpha,error,e,start,finish,T1,T2,T3,T4,Tg
parameter(e=0.000000001)
print*,"ENTER Velocity in x direction (U): "
read*,u
print*,"ENTER Velocity in y direction (V): "
read*,v
print*,"ENTER L (length=width): "
read*,Lx
1 continue
print*,"Enter Bottom Side Temperature(K): "
read*,T1
if (T1<0) then
goto 1
end if
2 continue
print*,"Enter Top Side Temperature(K): "
read*,T2
if (T2<0) then
goto 2
end if
3 continue
print*,"Enter Left Side Temperature(K): "
read*,T3
if (T3<0) then
goto 3
end if
4 continue
print*,"Enter Left Side Temperature(K): "
read*,T4
if (T4<0) then
goto 4
end if
print*,"Enter Initial guess of Temperature(K): "
read*,Tg
5 continue
print*,"ENTER (Nx>10) "
read*,Nx
if (Nx<10) then
goto 5
end if
6 continue
print*,"ENTER (Alpha>0): "
read*,Alpha
if (Alpha<=0) then
goto 6
end if
call cpu_time(start)
Ly=Lx
Ny=Nx
dx=Lx/(Nx-1)
dy=Ly/(Ny-1)
d=(dx/dy)**2
Pex=(u*dx)/Alpha
Pey=(v*dy)/Alpha
if (abs(Pex)>2.0.or.abs(Pey)>2.0) then
  print*,"abs(Pe) is Bigger than 2"
  goto 5
end if
open (5,file='Line by Line (row) .txt')
open (10,file='Results.PLT')
open (20,file='Line XCen.PLT')
open (25,file='Line YCen.PLT')
open (30,file='Error.PLT')
write(10,*)  'VARIABLES=x(m),y(m),T(K)'
write(10,*)  'ZONE i=',Nx,'j=',Ny 
write(20,*)  'VARIABLES=x(m),T(K)'
write(20,*)  'ZONE i=',Nx
write(25,*)  'VARIABLES=y(m),T(K)'
write(25,*)  'ZONE i=',Ny
write(30,*)  'VARIABLES=N,log(error)'
allocate(T(Nx,Ny),Told(Nx,Ny),x(Nx),y(Ny),a(Nx-2),b(Nx-2),c(Nx-2),r(Nx-2),s(Nx-2))
do i=1,Nx
 x(i)=(i-1)*dx
end do
do j=1,Ny
 y(j)=(j-1)*dy
end do
do i=1,Nx
 Told(i,1)=T1
 Told(i,Ny)=T2
end do
do j=1,Ny
 Told(1,j)=T3
 Told(Nx,j)=T4
end do  
do i=2,Nx-1
do j=2,Ny-1
 Told(i,j)=Tg
end do
end do 
error=1.0
T=Told
N=0
do while(error>e)
 N=N+1 
 error=0.0
 do j=2,Ny-1
  do i=2,Nx-1
   if (abs(Pex)<2.0.and.abs(Pey)<2.0)then
    a(i-1)= -(2+Pex)
    b(i-1)= 4*(1+d)
    c(i-1)= -(2-Pex)
    r(i-1)=d*(2-Pey)*Told(i,j+1)+d*(2+Pey)*Told(i,j-1)
    else !(abs(Pex)>2.0.and.abs(Pey)>2.0)
     if (u>0.0.and.v>0.0) then
      a(i-1)= -(1+Pex)
      b(i-1)= (d*Pey+Pex+2+2*d)
      c(i-1)= -1
      r(i-1)=d*(1+Pey)*Told(i,j-1)+d*Told(i,j+1)
     elseif(u<0.0.and.v>0.0) then
      a(i-1)= -1
      b(i-1)= (d*Pey-Pex+2+2*d)
      c(i-1)= -(1-Pex)
      r(i-1)=d*(1+Pey)*Told(i,j-1)+d*Told(i,j+1)
     elseif (u>0.0.and.v<0.0) then
      a(i-1)= -(1+Pex)
      b(i-1)= (Pex-d*Pey+2+2*d)
      c(i-1)= -1
      r(i-1)=d*Told(i,j-1)+d*(1-Pey)*Told(i,j+1)
     else if (u<0.0.and.v<0.0) then
      a(i-1)= -1
      b(i-1)= (2+2*d-Pex-d*Pey)
      c(i-1)= -(1-Pex)
      r(i-1)=d*(1-Pey)*Told(i,j-1)+d*(1-Pey)*Told(i,j+1)
     end if
   end if
  end do 
  i=2
  r(i-1)=r(i-1)-a(i-1)*T(i-1,j)
  i=Nx-1
  r(i-1)=r(i-1)-c(i-1)*T(i+1,j)
  call TDMA(a,b,c,r,s,Nx-2) 
  do i=2,Nx-1
   T(i,j)=s(i-1)
  end do
 end do
 do i=2,Nx-1
  do j=2,Ny-1
   error=error+abs( T(i,j)-Told(i,j) )/((Nx-2)*(Ny-2))
  end do
 end do
 write(30,*)N,log(error)
 print*,"Iteration: ",N," Error: ",error
 Told=T
end do
do i=1,Nx
 write(20,*)x(i),T(i,(Ny-1)/2)   
 do j=1,Ny
  write(10,*)x(i),y(j),T(i,j)           
 end do
end do
do j=1,Ny
 write(25,*)y(j),T((Nx-1)/2,j)           
end do
call cpu_time(finish)
write(5,*) "Nx:",Nx,"Ny:",Ny,"N:",N,"alpha:",alpha,"Cpu time",finish-start,"Pex",Pex,"Pey=",Pey
print*,"Pex=Pey= ",Pex," Number of iterations: ",N,"  Cpu time: ",finish-start
end program LinebyLineR
subroutine TDMA (a,b,c,r,s,n)
double precision,dimension(n)::a,b,c,r,s,aa,cc
aa(1)=-c(1)/b(1)
cc(1)=r(1)/b(1)
do i=2,n
if (b(1)==0)then
 print*,('zero encounterd in denominator')
 pause
end if
aa(i)=-c(i)/(b(i)+a(i)*aa(i-1))
cc(i)=(-a(i)*cc(i-1)+r(i))/(b(i)+a(i)*aa(i-1))
end do
s(n)=cc(n)
do i=n-1,1,-1
 s(i)=aa(i)*s(i+1)+cc(i)
end do
end